<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { request } from '@/lib/request';
import { useChatStore } from '@/stores/chat';
import { storeToRefs } from 'pinia';
import { inject, onMounted, ref } from 'vue';
import Modal from '@/components/general/Modal.vue';
import Input from "@/components/general/form/Input.vue";
import Accordion from "@/components/general/Accordion.vue";
import AccordionItem from "@/components/general/AccordionItem.vue";
import RadioButtonsGroup from '@/components/general/form/RadioButtonsGroup.vue';
import { useI18n } from 'vue-i18n';
import { useBaseStore } from '@/stores/base';

const emits = defineEmits<{
    (e: 'close'): void,
    (e: 'submit', value: string | undefined): void
}>();
const { t } = useI18n();
const $t = t;

const configuration = inject<any>('configuration');
const chatStore = useChatStore();
const baseStore = useBaseStore();
const { state, uuid } = storeToRefs(chatStore);
const { message } = storeToRefs(baseStore);
const { updateChatTitle } = chatStore;
const name = ref('');
const systemPrompt = ref('');

onMounted(async () => {
    if (state.value === 'IMAGE_EDIT' && uuid.value) {
        const result = await request('GET', configuration.apiServer + "/api/ai/chat/" + uuid.value, undefined, 'application/json', undefined, true);
        if (result.success) {
            name.value = result.chat.name;
        }
    }
});

const handleSubmit = async () => {
    if (state.value === 'IMAGE_CREATE') {
        const data = { name: name.value, systemprompt: systemPrompt.value, type: 'image', model: model.value, style: style.value };
        const result = await request('PUT', configuration.apiServer + "/api/ai/chat/", data, 'application/json', undefined, true);
        if (result.success) {
            emits('submit', result.uuid);
        }
    } else if (state.value === 'IMAGE_EDIT') {
        const data = { name: name.value };
        const result = await request('POST', configuration.apiServer + "/api/ai/chat/" + uuid.value, data, 'application/json', undefined, true);
        if (result.success) {
            message.value = $t('ai.general.variables.notification.update.success');
            emits('submit', undefined);
        }
        updateChatTitle(name.value);
    }
};

const handleCancel = () => {
    emits('close');
};

const isAccordionOpen = ref(false);
const handleOpenAccordion = () => {
    isAccordionOpen.value = !isAccordionOpen.value;
};

const styles = [
    { label: $t('ai.image.styles.default.label'), name: "default" },
    { label: $t('ai.image.styles.photo.label'), name: "photo" },
    { label: $t('ai.image.styles.sketch.label'), name: "sketch" },
    { label: $t('ai.image.styles.painting.label'), name: "painting" },
    { label: $t('ai.image.styles.cartoon.label'), name: "cartoon" },
    { label: $t('ai.image.styles.origami.label'), name: "origami" },
    { label: $t('ai.image.styles.claymation.label'), name: "claymation" }
];
const style = ref(styles[0].name);

const localModels = configuration.ai.models.image.sort((a: { label: string, value: string }, b: { label: string, value: string }) => {
    if (a.label < b.label) {
        return -1;
    }
    if (a.label > b.label) {
        return 1;
    }
    return 0;
}).map((item: { label: string, value: string }) => { return { name: item.value, label: item.label }; });
const model = ref(localModels[0].name);

</script>
<template>
    <Modal :header="state === 'IMAGE_EDIT' ? $t('ai.image.create.edit.label') : $t('ai.image.create.create.label')"
        @submit="handleSubmit" :labelSubmit="$t('general.buttons.save')" :disableSubmit="name.length === 0"
        :labelCancel="$t('general.buttons.cancel')" @cancel="handleCancel">
        <Input v-model="name" :label="$t('ai.image.create.name.label')" type="text"
            :placeholder="$t('ai.image.create.name.placeholder')" />
        <RadioButtonsGroup v-model="model" :label="$t('ai.image.create.model')" :items="localModels"
            v-if="state === 'IMAGE_CREATE' && localModels.length>1" columns/>
        <RadioButtonsGroup v-model="style" :items="styles" :label="$t('ai.image.style.label')" columns v-if="state === 'IMAGE_CREATE'" />
        <Accordion v-if="state === 'IMAGE_CREATE'">
            <AccordionItem :header="$t('ai.image.create.additionalFields.header')" :height="200"
                @click="handleOpenAccordion" :active="isAccordionOpen">
                <div class="flex flex-col gap-1">
                    <label>{{ $t('ai.image.create.systemprompt.label') }}</label>
                    <textarea
                        class="border border-gray-300 rounded-md resize-none p-2 text-gray-500 focus:outline-none focus-within:outline-none"
                        maxlength="4000" rows="6" v-model="systemPrompt"
                        :placeholder="$t('ai.image.create.systemprompt.placeholder')"></textarea>
                    <div class="text-right text-gray-500"> {{ systemPrompt.length }} / 4000</div>
                </div>
            </AccordionItem>
        </Accordion>
    </Modal>
</template>